#include "derived.h"

#include <dlfcn.h>

int main(int argc, char* argv[])
{
	void* base = dlopen("./libbase.so", RTLD_NOW);// | RTLD_GLOBAL);
	void* derived = dlopen("./libderived.so", RTLD_NOW);
	Tag* (*p_getTag)(Base*) = (Tag* (*)(Base*))dlsym(base, "_Z6getTagP4Base");
	VirtualTag* (*p_getVirtualTag)(Base*) = (VirtualTag* (*)(Base*))dlsym(base, "_Z13getVirtualTagP4Base");
	Tag* (*p_getTag2)(Base*) = (Tag* (*)(Base*))dlsym(derived, "_Z7getTag2P4Base");
	VirtualTag* (*p_getVirtualTag2)(Base*) = (VirtualTag* (*)(Base*))dlsym(derived, "_Z14getVirtualTag2P4Base");
	Derived0* (*p_createDerived0)() = (Derived0* (*)())dlsym(derived, "_Z14createDerived0v");
	Derived1* (*p_createDerived1)() = (Derived1* (*)())dlsym(derived, "_Z14createDerived1v");
	Base* p0 = p_createDerived0();
	Base* p1 = p_createDerived1();
	std::printf("getTag(p0): %p\n", p_getTag(p0));
	std::printf("getVirtualTag(p1): %p\n", p_getVirtualTag(p1));
	std::printf("getTag2(p0): %p\n", p_getTag2(p0));
	std::printf("getVirtualTag2(p1): %p\n", p_getVirtualTag2(p1));
	delete p0;
	delete p1;
	dlclose(base);
	dlclose(derived);
	return 0;
}
